﻿<template>
    <v-simple-table dense class="table-work">
        <template>
            <tbody>
                <tr>
                    <th>№</th>
                    <th>Название задачи</th>
                    <th>Выполнено(%)</th>
                    <th>Статус</th>
                    <th>Никнейм</th>
                    <th>Название проекта</th>
                    <th>Дата начала</th>
                    <th>Дата дедлайна</th>
                </tr>

                <tr v-for="(item, index) of taskArr" :key="index">
                    <td>{{ index + 1}}</td>
                    <td>{{ item.title }}</td>
                    <td>{{ item.progress }}</td>
                    <td>{{ getStatus(item.status) }}</td>
                    <td>{{ getUser(item.employeeId) }}</td>
                    <td>{{ getProject(item.projectId) }}</td>
                    <td>{{ formatDate(item.startDate) }}</td>
                    <td>{{ formatDate(item.estimatedDate) }}</td>
                </tr>
            </tbody>
        </template>
    </v-simple-table>
</template>

<script>
    import { mapActions, mapGetters } from 'vuex'

    export default {
        data() {
            return {
                taskArr: [],
                projectArr: [],
                userArr: [],
                employeeArr: []
            }
        },
        computed: {
            ...mapGetters('task', ['getTaskAllData']),
            ...mapGetters('project', ['getProjectAllData']),
            ...mapGetters('user', ['getUserData']),
            ...mapGetters('employee', ['getEmployeeAllData']),
        },
        methods: {
            ...mapActions('task', ['onTaskAllData']),
            ...mapActions('project', ['onProjectAllWithDetailsData']),
            ...mapActions('user', ['onUserData']),
            ...mapActions('employee', ['onEmployeeAllData']),
            getUser(employeeId) {
                if (this.getEmployeeAllData != null && this.getEmployeeAllData != undefined) {
                    let employee = this.getEmployeeAllData.find(rec => rec.id == employeeId);
                    if (employee === undefined)
                        return ''
                    let user = this.getUserData.find(rec => rec.id == employee.userId);
                    if (user === undefined)
                        return '';
                    return user.userName;
                }
                return '';
            },
            getProject(projectId) {
                if (this.getProjectAllData != null && this.getProjectAllData != undefined) {
                    let project = this.getProjectAllData.find(rec => rec.id == projectId);
                    if (project === undefined)
                        return '';
                    return project.title;
                }
                return '';
            },
            getStatus(status) {
                if (status === 0)
                    return 'Открыта';
                else if (status === 1)
                    return 'В процессе';
                else if (status === 2)
                    return 'Закрыта';
                else
                    return '';
            },
            formatDate(dateStr) {
                if (dateStr === undefined)
                    return;
                let date = new Date(dateStr);
                let formattedDate =
                    (date.getDate() > 9 ? date.getDate() : '0' + date.getDate()) +
                    '.' +
                    (date.getMonth() > 8
                        ? date.getMonth() + 1
                        : '0' + (date.getMonth() + 1)) +
                    '.' +
                    date.getFullYear()
                return formattedDate
            }
        },
        created() {
            this.onTaskAllData();
            this.onProjectAllWithDetailsData();
            this.onUserData();
            this.onEmployeeAllData();
        },
        watch: {
            getTaskAllData() {
                this.taskArr = this.getTaskAllData;
            },
            getProjectAllData() {
                this.projectArr = this.getProjectAllData;
            },
            getUserData() {
                this.userArr = this.getUserData;
            },
            getEmployeeAllData() {
                this.employeeArr = this.getEmployeeAllData;
            }
        }
    }
</script>